# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SecurityRuleArgs', 'SecurityRule']

@pulumi.input_type
class SecurityRuleArgs:
    def __init__(__self__, *,
                 action: pulumi.Input[str],
                 applications: pulumi.Input[Sequence[pulumi.Input[str]]],
                 category: pulumi.Input['SecurityRuleCategoryArgs'],
                 destination: pulumi.Input['SecurityRuleDestinationArgs'],
                 priority: pulumi.Input[int],
                 rulestack: pulumi.Input[str],
                 source: pulumi.Input['SecurityRuleSourceArgs'],
                 audit_comment: Optional[pulumi.Input[str]] = None,
                 decryption_rule_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 logging: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 prot_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 rule_list: Optional[pulumi.Input[str]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a SecurityRule resource.
        :param pulumi.Input[str] action: The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] applications: The list of applications.
        :param pulumi.Input['SecurityRuleCategoryArgs'] category: The category spec.
        :param pulumi.Input['SecurityRuleDestinationArgs'] destination: The destination spec.
        :param pulumi.Input[int] priority: The rule priority.
        :param pulumi.Input[str] rulestack: The rulestack.
        :param pulumi.Input['SecurityRuleSourceArgs'] source: The source spec.
        :param pulumi.Input[str] audit_comment: The audit comment.
        :param pulumi.Input[str] decryption_rule_type: Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input[bool] enabled: Set to false to disable this rule. Defaults to `true`.
        :param pulumi.Input[bool] logging: Enable logging at end. Defaults to `true`.
        :param pulumi.Input[str] name: The name.
        :param pulumi.Input[bool] negate_destination: Negate the destination definition.
        :param pulumi.Input[bool] negate_source: Negate the source definition.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] prot_port_lists: Protocol port list.
        :param pulumi.Input[str] protocol: The protocol.
        :param pulumi.Input[str] rule_list: The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        :param pulumi.Input[str] scope: The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: The tags.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "applications", applications)
        pulumi.set(__self__, "category", category)
        pulumi.set(__self__, "destination", destination)
        pulumi.set(__self__, "priority", priority)
        pulumi.set(__self__, "rulestack", rulestack)
        pulumi.set(__self__, "source", source)
        if audit_comment is not None:
            pulumi.set(__self__, "audit_comment", audit_comment)
        if decryption_rule_type is not None:
            pulumi.set(__self__, "decryption_rule_type", decryption_rule_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if logging is not None:
            pulumi.set(__self__, "logging", logging)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if negate_destination is not None:
            pulumi.set(__self__, "negate_destination", negate_destination)
        if negate_source is not None:
            pulumi.set(__self__, "negate_source", negate_source)
        if prot_port_lists is not None:
            pulumi.set(__self__, "prot_port_lists", prot_port_lists)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if rule_list is not None:
            pulumi.set(__self__, "rule_list", rule_list)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Input[str]:
        """
        The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: pulumi.Input[str]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def applications(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The list of applications.
        """
        return pulumi.get(self, "applications")

    @applications.setter
    def applications(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "applications", value)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Input['SecurityRuleCategoryArgs']:
        """
        The category spec.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: pulumi.Input['SecurityRuleCategoryArgs']):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def destination(self) -> pulumi.Input['SecurityRuleDestinationArgs']:
        """
        The destination spec.
        """
        return pulumi.get(self, "destination")

    @destination.setter
    def destination(self, value: pulumi.Input['SecurityRuleDestinationArgs']):
        pulumi.set(self, "destination", value)

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Input[int]:
        """
        The rule priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: pulumi.Input[int]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def rulestack(self) -> pulumi.Input[str]:
        """
        The rulestack.
        """
        return pulumi.get(self, "rulestack")

    @rulestack.setter
    def rulestack(self, value: pulumi.Input[str]):
        pulumi.set(self, "rulestack", value)

    @property
    @pulumi.getter
    def source(self) -> pulumi.Input['SecurityRuleSourceArgs']:
        """
        The source spec.
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: pulumi.Input['SecurityRuleSourceArgs']):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter(name="auditComment")
    def audit_comment(self) -> Optional[pulumi.Input[str]]:
        """
        The audit comment.
        """
        return pulumi.get(self, "audit_comment")

    @audit_comment.setter
    def audit_comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "audit_comment", value)

    @property
    @pulumi.getter(name="decryptionRuleType")
    def decryption_rule_type(self) -> Optional[pulumi.Input[str]]:
        """
        Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        """
        return pulumi.get(self, "decryption_rule_type")

    @decryption_rule_type.setter
    def decryption_rule_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "decryption_rule_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Set to false to disable this rule. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def logging(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable logging at end. Defaults to `true`.
        """
        return pulumi.get(self, "logging")

    @logging.setter
    def logging(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "logging", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> Optional[pulumi.Input[bool]]:
        """
        Negate the destination definition.
        """
        return pulumi.get(self, "negate_destination")

    @negate_destination.setter
    def negate_destination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_destination", value)

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> Optional[pulumi.Input[bool]]:
        """
        Negate the source definition.
        """
        return pulumi.get(self, "negate_source")

    @negate_source.setter
    def negate_source(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_source", value)

    @property
    @pulumi.getter(name="protPortLists")
    def prot_port_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Protocol port list.
        """
        return pulumi.get(self, "prot_port_lists")

    @prot_port_lists.setter
    def prot_port_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "prot_port_lists", value)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[pulumi.Input[str]]:
        """
        The protocol.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="ruleList")
    def rule_list(self) -> Optional[pulumi.Input[str]]:
        """
        The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        """
        return pulumi.get(self, "rule_list")

    @rule_list.setter
    def rule_list(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_list", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _SecurityRuleState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 audit_comment: Optional[pulumi.Input[str]] = None,
                 category: Optional[pulumi.Input['SecurityRuleCategoryArgs']] = None,
                 decryption_rule_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination: Optional[pulumi.Input['SecurityRuleDestinationArgs']] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 logging: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 prot_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 rule_list: Optional[pulumi.Input[str]] = None,
                 rulestack: Optional[pulumi.Input[str]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input['SecurityRuleSourceArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 update_token: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SecurityRule resources.
        :param pulumi.Input[str] action: The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] applications: The list of applications.
        :param pulumi.Input[str] audit_comment: The audit comment.
        :param pulumi.Input['SecurityRuleCategoryArgs'] category: The category spec.
        :param pulumi.Input[str] decryption_rule_type: Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input['SecurityRuleDestinationArgs'] destination: The destination spec.
        :param pulumi.Input[bool] enabled: Set to false to disable this rule. Defaults to `true`.
        :param pulumi.Input[bool] logging: Enable logging at end. Defaults to `true`.
        :param pulumi.Input[str] name: The name.
        :param pulumi.Input[bool] negate_destination: Negate the destination definition.
        :param pulumi.Input[bool] negate_source: Negate the source definition.
        :param pulumi.Input[int] priority: The rule priority.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] prot_port_lists: Protocol port list.
        :param pulumi.Input[str] protocol: The protocol.
        :param pulumi.Input[str] rule_list: The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        :param pulumi.Input[str] rulestack: The rulestack.
        :param pulumi.Input[str] scope: The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        :param pulumi.Input['SecurityRuleSourceArgs'] source: The source spec.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: The tags.
        :param pulumi.Input[str] update_token: The update token.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if applications is not None:
            pulumi.set(__self__, "applications", applications)
        if audit_comment is not None:
            pulumi.set(__self__, "audit_comment", audit_comment)
        if category is not None:
            pulumi.set(__self__, "category", category)
        if decryption_rule_type is not None:
            pulumi.set(__self__, "decryption_rule_type", decryption_rule_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if destination is not None:
            pulumi.set(__self__, "destination", destination)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if logging is not None:
            pulumi.set(__self__, "logging", logging)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if negate_destination is not None:
            pulumi.set(__self__, "negate_destination", negate_destination)
        if negate_source is not None:
            pulumi.set(__self__, "negate_source", negate_source)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if prot_port_lists is not None:
            pulumi.set(__self__, "prot_port_lists", prot_port_lists)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if rule_list is not None:
            pulumi.set(__self__, "rule_list", rule_list)
        if rulestack is not None:
            pulumi.set(__self__, "rulestack", rulestack)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)
        if source is not None:
            pulumi.set(__self__, "source", source)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if update_token is not None:
            pulumi.set(__self__, "update_token", update_token)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def applications(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of applications.
        """
        return pulumi.get(self, "applications")

    @applications.setter
    def applications(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "applications", value)

    @property
    @pulumi.getter(name="auditComment")
    def audit_comment(self) -> Optional[pulumi.Input[str]]:
        """
        The audit comment.
        """
        return pulumi.get(self, "audit_comment")

    @audit_comment.setter
    def audit_comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "audit_comment", value)

    @property
    @pulumi.getter
    def category(self) -> Optional[pulumi.Input['SecurityRuleCategoryArgs']]:
        """
        The category spec.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: Optional[pulumi.Input['SecurityRuleCategoryArgs']]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter(name="decryptionRuleType")
    def decryption_rule_type(self) -> Optional[pulumi.Input[str]]:
        """
        Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        """
        return pulumi.get(self, "decryption_rule_type")

    @decryption_rule_type.setter
    def decryption_rule_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "decryption_rule_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def destination(self) -> Optional[pulumi.Input['SecurityRuleDestinationArgs']]:
        """
        The destination spec.
        """
        return pulumi.get(self, "destination")

    @destination.setter
    def destination(self, value: Optional[pulumi.Input['SecurityRuleDestinationArgs']]):
        pulumi.set(self, "destination", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Set to false to disable this rule. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def logging(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable logging at end. Defaults to `true`.
        """
        return pulumi.get(self, "logging")

    @logging.setter
    def logging(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "logging", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> Optional[pulumi.Input[bool]]:
        """
        Negate the destination definition.
        """
        return pulumi.get(self, "negate_destination")

    @negate_destination.setter
    def negate_destination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_destination", value)

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> Optional[pulumi.Input[bool]]:
        """
        Negate the source definition.
        """
        return pulumi.get(self, "negate_source")

    @negate_source.setter
    def negate_source(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "negate_source", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        The rule priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="protPortLists")
    def prot_port_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Protocol port list.
        """
        return pulumi.get(self, "prot_port_lists")

    @prot_port_lists.setter
    def prot_port_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "prot_port_lists", value)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[pulumi.Input[str]]:
        """
        The protocol.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="ruleList")
    def rule_list(self) -> Optional[pulumi.Input[str]]:
        """
        The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        """
        return pulumi.get(self, "rule_list")

    @rule_list.setter
    def rule_list(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_list", value)

    @property
    @pulumi.getter
    def rulestack(self) -> Optional[pulumi.Input[str]]:
        """
        The rulestack.
        """
        return pulumi.get(self, "rulestack")

    @rulestack.setter
    def rulestack(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rulestack", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def source(self) -> Optional[pulumi.Input['SecurityRuleSourceArgs']]:
        """
        The source spec.
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: Optional[pulumi.Input['SecurityRuleSourceArgs']]):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="updateToken")
    def update_token(self) -> Optional[pulumi.Input[str]]:
        """
        The update token.
        """
        return pulumi.get(self, "update_token")

    @update_token.setter
    def update_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_token", value)


class SecurityRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 audit_comment: Optional[pulumi.Input[str]] = None,
                 category: Optional[pulumi.Input[Union['SecurityRuleCategoryArgs', 'SecurityRuleCategoryArgsDict']]] = None,
                 decryption_rule_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination: Optional[pulumi.Input[Union['SecurityRuleDestinationArgs', 'SecurityRuleDestinationArgsDict']]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 logging: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 prot_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 rule_list: Optional[pulumi.Input[str]] = None,
                 rulestack: Optional[pulumi.Input[str]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[Union['SecurityRuleSourceArgs', 'SecurityRuleSourceArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Resource for security rule manipulation.

        ## Admin Permission Type

        * `Rulestack` (for `scope="Local"`)
        * `Global Rulestack` (for `scope="Global"`)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_cloudngfwaws as cloudngfwaws

        r = cloudngfwaws.Rulestack("r",
            name="terraform-rulestack",
            scope="Local",
            account_id="123456789",
            description="Made by Pulumi",
            profile_config={
                "anti_spyware": "BestPractice",
            })
        example = cloudngfwaws.SecurityRule("example",
            rulestack=r.name,
            rule_list="LocalRule",
            priority=3,
            name="tf-security-rule",
            description="Also configured by Terraform",
            source={
                "cidrs": ["any"],
            },
            destination={
                "cidrs": ["192.168.0.0/16"],
            },
            negate_destination=True,
            applications=["any"],
            category={},
            action="Allow",
            logging=True,
            audit_comment="initial config")
        ```

        ## Import

        import name is <scope>:<rulestack>:<rule_list>:<priority>

        ```sh
        $ pulumi import cloudngfwaws:index/securityRule:SecurityRule example Local:terraform-rulestack:LocalRule:3
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] applications: The list of applications.
        :param pulumi.Input[str] audit_comment: The audit comment.
        :param pulumi.Input[Union['SecurityRuleCategoryArgs', 'SecurityRuleCategoryArgsDict']] category: The category spec.
        :param pulumi.Input[str] decryption_rule_type: Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input[Union['SecurityRuleDestinationArgs', 'SecurityRuleDestinationArgsDict']] destination: The destination spec.
        :param pulumi.Input[bool] enabled: Set to false to disable this rule. Defaults to `true`.
        :param pulumi.Input[bool] logging: Enable logging at end. Defaults to `true`.
        :param pulumi.Input[str] name: The name.
        :param pulumi.Input[bool] negate_destination: Negate the destination definition.
        :param pulumi.Input[bool] negate_source: Negate the source definition.
        :param pulumi.Input[int] priority: The rule priority.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] prot_port_lists: Protocol port list.
        :param pulumi.Input[str] protocol: The protocol.
        :param pulumi.Input[str] rule_list: The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        :param pulumi.Input[str] rulestack: The rulestack.
        :param pulumi.Input[str] scope: The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        :param pulumi.Input[Union['SecurityRuleSourceArgs', 'SecurityRuleSourceArgsDict']] source: The source spec.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: The tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SecurityRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource for security rule manipulation.

        ## Admin Permission Type

        * `Rulestack` (for `scope="Local"`)
        * `Global Rulestack` (for `scope="Global"`)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_cloudngfwaws as cloudngfwaws

        r = cloudngfwaws.Rulestack("r",
            name="terraform-rulestack",
            scope="Local",
            account_id="123456789",
            description="Made by Pulumi",
            profile_config={
                "anti_spyware": "BestPractice",
            })
        example = cloudngfwaws.SecurityRule("example",
            rulestack=r.name,
            rule_list="LocalRule",
            priority=3,
            name="tf-security-rule",
            description="Also configured by Terraform",
            source={
                "cidrs": ["any"],
            },
            destination={
                "cidrs": ["192.168.0.0/16"],
            },
            negate_destination=True,
            applications=["any"],
            category={},
            action="Allow",
            logging=True,
            audit_comment="initial config")
        ```

        ## Import

        import name is <scope>:<rulestack>:<rule_list>:<priority>

        ```sh
        $ pulumi import cloudngfwaws:index/securityRule:SecurityRule example Local:terraform-rulestack:LocalRule:3
        ```

        :param str resource_name: The name of the resource.
        :param SecurityRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecurityRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 audit_comment: Optional[pulumi.Input[str]] = None,
                 category: Optional[pulumi.Input[Union['SecurityRuleCategoryArgs', 'SecurityRuleCategoryArgsDict']]] = None,
                 decryption_rule_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination: Optional[pulumi.Input[Union['SecurityRuleDestinationArgs', 'SecurityRuleDestinationArgsDict']]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 logging: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 negate_destination: Optional[pulumi.Input[bool]] = None,
                 negate_source: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 prot_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 rule_list: Optional[pulumi.Input[str]] = None,
                 rulestack: Optional[pulumi.Input[str]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[Union['SecurityRuleSourceArgs', 'SecurityRuleSourceArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecurityRuleArgs.__new__(SecurityRuleArgs)

            if action is None and not opts.urn:
                raise TypeError("Missing required property 'action'")
            __props__.__dict__["action"] = action
            if applications is None and not opts.urn:
                raise TypeError("Missing required property 'applications'")
            __props__.__dict__["applications"] = applications
            __props__.__dict__["audit_comment"] = audit_comment
            if category is None and not opts.urn:
                raise TypeError("Missing required property 'category'")
            __props__.__dict__["category"] = category
            __props__.__dict__["decryption_rule_type"] = decryption_rule_type
            __props__.__dict__["description"] = description
            if destination is None and not opts.urn:
                raise TypeError("Missing required property 'destination'")
            __props__.__dict__["destination"] = destination
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["logging"] = logging
            __props__.__dict__["name"] = name
            __props__.__dict__["negate_destination"] = negate_destination
            __props__.__dict__["negate_source"] = negate_source
            if priority is None and not opts.urn:
                raise TypeError("Missing required property 'priority'")
            __props__.__dict__["priority"] = priority
            __props__.__dict__["prot_port_lists"] = prot_port_lists
            __props__.__dict__["protocol"] = protocol
            __props__.__dict__["rule_list"] = rule_list
            if rulestack is None and not opts.urn:
                raise TypeError("Missing required property 'rulestack'")
            __props__.__dict__["rulestack"] = rulestack
            __props__.__dict__["scope"] = scope
            if source is None and not opts.urn:
                raise TypeError("Missing required property 'source'")
            __props__.__dict__["source"] = source
            __props__.__dict__["tags"] = tags
            __props__.__dict__["update_token"] = None
        super(SecurityRule, __self__).__init__(
            'cloudngfwaws:index/securityRule:SecurityRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            applications: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            audit_comment: Optional[pulumi.Input[str]] = None,
            category: Optional[pulumi.Input[Union['SecurityRuleCategoryArgs', 'SecurityRuleCategoryArgsDict']]] = None,
            decryption_rule_type: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            destination: Optional[pulumi.Input[Union['SecurityRuleDestinationArgs', 'SecurityRuleDestinationArgsDict']]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            logging: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            negate_destination: Optional[pulumi.Input[bool]] = None,
            negate_source: Optional[pulumi.Input[bool]] = None,
            priority: Optional[pulumi.Input[int]] = None,
            prot_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            protocol: Optional[pulumi.Input[str]] = None,
            rule_list: Optional[pulumi.Input[str]] = None,
            rulestack: Optional[pulumi.Input[str]] = None,
            scope: Optional[pulumi.Input[str]] = None,
            source: Optional[pulumi.Input[Union['SecurityRuleSourceArgs', 'SecurityRuleSourceArgsDict']]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            update_token: Optional[pulumi.Input[str]] = None) -> 'SecurityRule':
        """
        Get an existing SecurityRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] applications: The list of applications.
        :param pulumi.Input[str] audit_comment: The audit comment.
        :param pulumi.Input[Union['SecurityRuleCategoryArgs', 'SecurityRuleCategoryArgsDict']] category: The category spec.
        :param pulumi.Input[str] decryption_rule_type: Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input[Union['SecurityRuleDestinationArgs', 'SecurityRuleDestinationArgsDict']] destination: The destination spec.
        :param pulumi.Input[bool] enabled: Set to false to disable this rule. Defaults to `true`.
        :param pulumi.Input[bool] logging: Enable logging at end. Defaults to `true`.
        :param pulumi.Input[str] name: The name.
        :param pulumi.Input[bool] negate_destination: Negate the destination definition.
        :param pulumi.Input[bool] negate_source: Negate the source definition.
        :param pulumi.Input[int] priority: The rule priority.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] prot_port_lists: Protocol port list.
        :param pulumi.Input[str] protocol: The protocol.
        :param pulumi.Input[str] rule_list: The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        :param pulumi.Input[str] rulestack: The rulestack.
        :param pulumi.Input[str] scope: The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        :param pulumi.Input[Union['SecurityRuleSourceArgs', 'SecurityRuleSourceArgsDict']] source: The source spec.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: The tags.
        :param pulumi.Input[str] update_token: The update token.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SecurityRuleState.__new__(_SecurityRuleState)

        __props__.__dict__["action"] = action
        __props__.__dict__["applications"] = applications
        __props__.__dict__["audit_comment"] = audit_comment
        __props__.__dict__["category"] = category
        __props__.__dict__["decryption_rule_type"] = decryption_rule_type
        __props__.__dict__["description"] = description
        __props__.__dict__["destination"] = destination
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["logging"] = logging
        __props__.__dict__["name"] = name
        __props__.__dict__["negate_destination"] = negate_destination
        __props__.__dict__["negate_source"] = negate_source
        __props__.__dict__["priority"] = priority
        __props__.__dict__["prot_port_lists"] = prot_port_lists
        __props__.__dict__["protocol"] = protocol
        __props__.__dict__["rule_list"] = rule_list
        __props__.__dict__["rulestack"] = rulestack
        __props__.__dict__["scope"] = scope
        __props__.__dict__["source"] = source
        __props__.__dict__["tags"] = tags
        __props__.__dict__["update_token"] = update_token
        return SecurityRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        The action to take. Valid values are `Allow`, `DenySilent`, `DenyResetServer`, or `DenyResetBoth`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def applications(self) -> pulumi.Output[Sequence[str]]:
        """
        The list of applications.
        """
        return pulumi.get(self, "applications")

    @property
    @pulumi.getter(name="auditComment")
    def audit_comment(self) -> pulumi.Output[Optional[str]]:
        """
        The audit comment.
        """
        return pulumi.get(self, "audit_comment")

    @property
    @pulumi.getter
    def category(self) -> pulumi.Output['outputs.SecurityRuleCategory']:
        """
        The category spec.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter(name="decryptionRuleType")
    def decryption_rule_type(self) -> pulumi.Output[Optional[str]]:
        """
        Decryption rule type. Valid values are ``or`SSLOutboundInspection`.
        """
        return pulumi.get(self, "decryption_rule_type")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def destination(self) -> pulumi.Output['outputs.SecurityRuleDestination']:
        """
        The destination spec.
        """
        return pulumi.get(self, "destination")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Set to false to disable this rule. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def logging(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable logging at end. Defaults to `true`.
        """
        return pulumi.get(self, "logging")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="negateDestination")
    def negate_destination(self) -> pulumi.Output[Optional[bool]]:
        """
        Negate the destination definition.
        """
        return pulumi.get(self, "negate_destination")

    @property
    @pulumi.getter(name="negateSource")
    def negate_source(self) -> pulumi.Output[Optional[bool]]:
        """
        Negate the source definition.
        """
        return pulumi.get(self, "negate_source")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[int]:
        """
        The rule priority.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter(name="protPortLists")
    def prot_port_lists(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Protocol port list.
        """
        return pulumi.get(self, "prot_port_lists")

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Output[Optional[str]]:
        """
        The protocol.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="ruleList")
    def rule_list(self) -> pulumi.Output[Optional[str]]:
        """
        The rulebase. Valid values are `PreRule`, `PostRule`, or `LocalRule`. Defaults to `PreRule`.
        """
        return pulumi.get(self, "rule_list")

    @property
    @pulumi.getter
    def rulestack(self) -> pulumi.Output[str]:
        """
        The rulestack.
        """
        return pulumi.get(self, "rulestack")

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Output[Optional[str]]:
        """
        The rulestack's scope. A local rulestack will require that you've retrieved a LRA JWT. A global rulestack will require that you've retrieved a GRA JWT. Valid values are `Local` or `Global`. Defaults to `Local`.
        """
        return pulumi.get(self, "scope")

    @property
    @pulumi.getter
    def source(self) -> pulumi.Output['outputs.SecurityRuleSource']:
        """
        The source spec.
        """
        return pulumi.get(self, "source")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        The tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updateToken")
    def update_token(self) -> pulumi.Output[str]:
        """
        The update token.
        """
        return pulumi.get(self, "update_token")

